﻿using System.Windows;
using System.Windows.Media;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Charting;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private PointMark currentPointmark;

        public Window1()
        {
            InitializeComponent();

            DataSeries series = new DataSeries();
            series.Definition = new LineSeriesDefinition();
            series.Definition.ItemStyle = this.LayoutRoot.Resources["CustomStyle"] as Style;
            series.Definition.Appearance.PointMark.Shape = MarkerShape.Square;

            series.Add(new DataPoint(21));
            series.Add(new DataPoint(25));
            series.Add(new DataPoint(15));
            series.Add(new DataPoint(11));
            series.Add(new DataPoint(16));

            RadChart1.DefaultView.ChartArea.DataSeries.Add(series);
            RadChart1.DefaultView.ChartArea.AxisX.LayoutMode = AxisLayoutMode.Inside;
        }

        private void RadMenuItem_Click(object sender, Telerik.Windows.RadRoutedEventArgs e)
        {
            if (this.currentPointmark != null)
            {
                this.RestorePointMarkAppearance();
                this.RestorePointMarkSize();
            }
            
            RadContextMenu contextMenu = sender as RadContextMenu;

            this.currentPointmark = contextMenu.GetClickedElement<PointMark>();
            this.SetPointMarkAppearance();
            this.SetPointMarkSize(20);
        }

        private void RestorePointMarkAppearance()
        {
            this.currentPointmark.ClearValue(PointMark.BackgroundProperty);
            this.currentPointmark.ClearValue(PointMark.BorderBrushProperty);
        }

        private void SetPointMarkAppearance()
        {
            this.currentPointmark.Background = Brushes.Green;
            this.currentPointmark.BorderBrush = Brushes.Yellow;
        }

        private void SetPointMarkSize(int size)
        {
            this.currentPointmark.Size += size;
            this.currentPointmark.PointMarkCanvasLeft -= size / 2;
            this.currentPointmark.PointMarkCanvasTop -= size / 2;
        }

        private void RestorePointMarkSize()
        {
            this.currentPointmark.ClearValue(PointMark.SizeProperty);
            this.currentPointmark.PointMarkCanvasLeft = -5;
            this.currentPointmark.PointMarkCanvasTop = -5;
        }
    }
}
